% ..  .
%   MATLAB. 2023
%Script 1.10
%    
clc; clear all; close all
%  
%     
fun=@(t) exp(-2*t.^2).*(t>=0);
%   
tmax=1.2;
% 
dt=.01;
% 
t=0:dt:tmax;
%     
subplot(2,1,1)
u=fun(t);
plot(t,u)
grid
xlabel('\alphat')
ylabel('p(t)/P_{max}')
xlim([0 tmax])
ymi=0; yma=1.1;
ylim([ymi yma])
title('    ')
%1- 
% 
p0=.5;
% 
T0=.5;
%     
T(1)=fzero(@(t) fun(t)-p0,T0);
%2- 
%   -     
% 
E=integral(@(t) fun(t),0,inf);
T(2)=E;
%3- 
%   
gamma=.9;
%     
int_fun=@(x) arrayfun(@(x)integral(@(t)fun(t)/E,0,x),x);
%     
T(3)=fzero(@(x) int_fun(x)-gamma,1);
%4- 
%     - 
%   
T(4)=sqrt(integral(@(t) t.^2.*fun(t),0,inf)/E);
%    
x0=.9; vy=[.9 .7 .5 .3];
for k=1:4
y0=vy(k);
text(x0,y0,[num2str(k),') \alphaT/2 = ',num2str(T(k))])
end
% 
hold on
for k=1:4
stem(T(k),0,'filled','MarkerSize',2,'MarkerEdgeColor','Red')
stem(T(k),fun(T(k)),'--','filled','MarkerSize',2,'MarkerEdgeColor','Red')
text(T(k)+.01,fun(T(k))+.05,num2str(k))
end
line([0 T(1)],[fun(T(1)) fun(T(1))],'LineStyle','--')
stem(0,fun(T(1)),'filled','MarkerSize',2,'MarkerEdgeColor','Red')
line([T(2) T(2)],[fun(T(2)) 1],'LineStyle','--')
line([0 T(2)],[1 1],'LineStyle','--')
stem(0,1,'filled','MarkerSize',2,'MarkerEdgeColor','Red')
%     
subplot(2,1,2)
y=int_fun(t);
plot(t,y)
grid
xlabel('\alphaT')
ylabel('\gamma')
xlim([0 tmax])
ylim([ymi yma])
title('   ')
%    
k=1:4; g=int_fun(T(k));
vy=[.8 .6 .4 .2];
for k=1:4
y0=vy(k);
text(x0,y0,[num2str(k),') \gamma = ',num2str(g(k))])
end
% 
hold on
for k=1:4
stem(T(k),0,'filled','MarkerSize',2,'MarkerEdgeColor','Red')
stem(T(k),g(k),'--','filled','MarkerSize',2,'MarkerEdgeColor','Red')
line([0 T(k)],[g(k) g(k)],'LineStyle','--')
stem(0,g(k),'filled','MarkerSize',2,'MarkerEdgeColor','Red')
text(T(k)+.01,g(k)-.08,num2str(k))
end