% ..  .
%   MATLAB. 2023
%Script 1.8
%      
clear all; close all; clc
%  
%     
tmin=-.75;
tmax=.75;
% 
dt=.001;
% 
t=tmin:dt:tmax;
nt=length(t);
% 
fun_rect=@(x,e) 1/e*(abs(x)<=e/2);
%  ""
epsilon=[1 .5 .25]; 
ne=length(epsilon);
%  
a=zeros(ne,nt);
b=zeros(ne,nt);
str_leg=cell(ne,1);
% 
for k=1:ne;
str_leg{k}=['\epsilon = ',num2str(epsilon(k))];
e=epsilon(k);
a(k,:)=fun_rect(t,e);
b(k,:)=arrayfun(@(t)integral(@(x)fun_rect(x,e),tmin,t),t);
end
% 
subplot(2,1,1)
plot(t,a)
grid
xlabel('t')
ylabel('a_{\epsilon}(t)')
title(' ')
umi=-0.1;
uma=max(max(a))*1.1;
xlim([tmin tmax])
ylim([umi uma])
legend(str_leg)
% 
subplot(2,1,2)
plot(t,b)
grid
xlabel('t')
ylabel('b_{\epsilon}(t)')
umi=-0.2;
uma=1.2;
xlim([tmin tmax])
ylim([umi uma])
legend(str_leg,'Location','NorthWest')
% 
fun_gaus=@(x,e) 1/sqrt(2*pi*e^2)*exp(-x.^2/(2*e^2));
%  ""
epsilon=[.2 .1 .05];
% 
for k=1:ne;
str_leg{k}=['\epsilon = ',num2str(epsilon(k))];
e=epsilon(k);
a(k,:)=fun_gaus(t,e);
b(k,:)=arrayfun(@(t)integral(@(x)fun_gaus(x,e),tmin,t),t);
end
% 
figure
subplot(2,1,1)
plot(t,a)
grid
xlabel('t')
ylabel('a_{\epsilon}(t)')
title(' ')
umi=-0.2;
uma=max(max(a))*1.1;
xlim([tmin tmax])
ylim([umi uma])
legend(str_leg)
% 
subplot(2,1,2)
plot(t,b)
xlabel('t')
ylabel('b_{\epsilon}(t)')
grid
uma=1.2;
xlim([tmin tmax])
ylim([umi uma])
legend(str_leg,'Location','NorthWest')
%  sin(t)/t
fun_sin=@(x,e) 1./(pi*x).*sin(x/e);
%  ""
epsilon=[.1 .05 .025];
% 
for k=1:ne;
str_leg{k}=['\epsilon = ',num2str(epsilon(k))];
e=epsilon(k);
a(k,:)=fun_sin(t,e);
b(k,:)=arrayfun(@(t)integral(@(x)fun_sin(x,e),10*tmin,t),t);
end
% 
figure
subplot(2,1,1)
plot(t,a)
grid
xlabel('t')
ylabel('a_{\epsilon}(t)')
title('  sin(t)/t')
umi=min(min(a))*1.1;
uma=max(max(a))*1.1;
xlim([tmin tmax])
ylim([umi uma])
legend(str_leg)
% 
subplot(2,1,2)
plot(t,b)
xlabel('t')
ylabel('b_{\epsilon}(t)')
grid
uma=1.2;
umi=-.2;
xlim([tmin tmax])
ylim([umi uma])
legend(str_leg,'Location','NorthWest')