% ..  .
%   MATLAB. 2023
%Script 3.10
%     
clc; clear all; close all
%  
% 
U0=1;
% 
T=1;
%   
tmax=T;
% 
vf0=[3/T 5/T 10/T];
nf0=length(vf0);
%     
kf=100;
%     
N_peaks=5;
%   
df=.001;
%    
for k=1:nf0
% 
f0=vf0(k);
% 
fs=kf*f0;
% 
dt=1/fs;
%  
t=-tmax:dt:tmax;
% 
fun=@(t) cos(pi*t/T).*cos(2*pi*f0*t).*(abs(t)<=T/2);
% 
u=U0*fun(t);
figure
subplot(3,1,1)
plot(t,u,t,U0*cos(pi*t/T).*(abs(t)<=T/2),'b--')
ylim([-U0-.1 U0+.1])
grid
xlabel('t, ')
ylabel('u(t), ')
str=[' , U_0 = ',num2str(U0),...
' , T = ',num2str(T),' , f_0 = ' ,num2str(f0),' '];
title(str)
%  
fmax=f0+N_peaks/T;
%  
f=-fmax:df:fmax;
%     
UF=integral(@(t)U0*fun(t).*cos(2*pi*f*t),-T/2,T/2,'ArrayValued',true);
subplot(3,1,2)
plot(f,UF)
ylim([min(UF)-.1 U0*T/4+.1])
grid
xlabel('f, ')
ylabel('U_F(f), /')
title('  ()')
%   
subplot(3,1,3)
U=U0*T/pi*(cos(pi*(f-f0)*T)./(1-(2*(f-f0)*T).^2)...
+cos(pi*(f+f0)*T)./(1-(2*(f+f0)*T).^2));
%   |f-f0|=1/(2T),|f+f0|=1/(2T) 
iu=find(U==Inf);
U(iu)=U0*T/4;
plot(f,U)
ylim([min(UF)-.1 U0*T/4+.1])
grid
xlabel('f, ')
ylabel('U(f), /')
title('  ()')
%   
dU=max(abs(UF-U));
fprintf('  %f :\n',f0)
fprintf('-  : %e /.\n',dU)
end