% ..  .
%   MATLAB. 2023
%Script 4.1
%    
clear all; close all; clc
%  
%  
tau=.1;
%     
tmin=0; tmax=4*tau;
%   
dt=.01;
%  
t=0:dt:tmax;
% 
Fc=1/(2*pi*tau);
%     
fmin=0; fmax=round(1.5*pi*Fc);
%   
df=.01;
%  
f=0:df:fmax;
%1-  
%  
% 
subplot(2,2,1)
h=exp(-t/tau)/tau;
plot(t,h)
grid
hmax=max(h);
ymin=0; ymax=1.1*hmax;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('h(t), ^{-1}')
title(['   (), \tau_c = ',num2str(tau),...
' , F_c = ',num2str(Fc),' '],...
'Units','normalized','Position',[1.147 1.03 0])
line([0 tau],[hmax 0],'LineStyle','--')
% 
subplot(2,2,2)
k=1-exp(-t/tau);
plot(t,k)
grid
ymin=0; ymax=1.1;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('k(t)')
line([0 tmax],[1 1],'LineStyle','--')
line([0 tau],[0 1],'LineStyle','--')
line([tau tau],[1 0],'LineStyle','--')
%  
A=1./sqrt(1+(f/Fc).^2);
subplot(2,2,3)
plot(f,A)
grid
ymin=0; ymax=1.1;
xlim([fmin fmax])
ylim([ymin ymax])
xlabel('f, ')
ylabel('|H(f)|')
line([0 Fc],[1/sqrt(2) 1/sqrt(2)],'LineStyle','--')
line([Fc Fc],[1/sqrt(2) 0],'LineStyle','--')
%  
phi=-atan2(f,Fc);
subplot(2,2,4)
plot(f,phi)
grid
ymin=-pi/2-.1; ymax=0.1;
xlim([fmin fmax])
ylim([ymin ymax])
xlabel('f, ')
ylabel('\phi(f), ')
line([0 Fc],[-pi/4 -pi/4],'LineStyle','--')
line([Fc Fc],[0 -pi/4],'LineStyle','--')
%2-  
%   
% 
b=[0 1];
% 
a=[tau 1];
%  
disp(' :')
sys=tf(b,a)
%  
hs=impulse(sys,t);
ks=step(sys,t);
Hv=freqresp(sys,f,'Hz');
Hs=reshape(Hv,1,length(Hv));
% 
figure
% 
subplot(2,2,1)
plot(t,hs)
grid
hmax=max(hs);
ymin=0; ymax=1.1*hmax;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('h(t), ^{-1}')
title(['   (), \tau_c = ',num2str(tau),...
' , F_c = ',num2str(Fc),' '],...
'Units','normalized','Position',[1.147 1.03 0])
line([0 tau],[hmax 0],'LineStyle','--')
% 
subplot(2,2,2)
plot(t,ks)
grid
ymin=0; ymax=1.1;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('k(t)')
line([0 tmax],[1 1],'LineStyle','--')
line([0 tau],[0 1],'LineStyle','--')
line([tau tau],[1 0],'LineStyle','--')
%  
subplot(2,2,3)
plot(f,abs(Hs))
grid
ymin=0; ymax=1.1;
xlim([fmin fmax])
ylim([ymin ymax])
xlabel('f, ')
ylabel('|H(f)|')
line([0 Fc],[1/sqrt(2) 1/sqrt(2)],'LineStyle','--')
line([Fc Fc],[1/sqrt(2) 0],'LineStyle','--')
%  
subplot(2,2,4)
plot(f,angle(Hs))
grid
ymin=-pi/2-.1; ymax=0.1;
xlim([fmin fmax])
ylim([ymin ymax])
xlabel('f, ')
ylabel('\phi(f), ')
line([0 Fc],[-pi/4 -pi/4],'LineStyle','--')
line([Fc Fc],[0 -pi/4],'LineStyle','--')
%   
disp('  :')
dh=max(abs(h-hs'));
fprintf('- : %e 1/;\n',dh)
dk=max(abs(k-ks'));
fprintf('- : %e;\n',dk)
% 
H=1./(1+1i*(f/Fc));
dH=max(abs(H-Hs));
fprintf('-  : %e.\n',dH)