% ..  .
%   MATLAB. 2023
%Script 4.2
%       
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
%     
tmin=0; tmax=2*T;
%   
dt=.01;
%  
t=0:dt:tmax;
%  
vtau=[.1 .2 .4];
%  
y=zeros(length(t),length(vtau));
ys=zeros(length(t),length(vtau));
str_leg=cell(length(vtau),1);
%  
x=U0*rectpuls(t-T/2,T);
%      
for k=1:length(vtau)
tau=vtau(k);
str_leg{k}=['\tau_c = ',num2str(tau),' '];
%  
yf=@(t) U0*(1-exp(-t/tau)).*(t>=0)-U0*(1-exp(-(t-T)/tau)).*(t>=T);
y(:,k)=yf(t);
%  
sys=tf([0 1],[tau 1]);
% 
ys(:,k)=lsim(sys,x,t); 
%   
dy=max(abs(y(:,k)-ys(:,k)));
fprintf('     %f :\n',tau)
fprintf('-  : %e .\n',dy)
end
% 
subplot(2,1,1)
plot(t,y)
grid
ymin=0; ymax=1.3*U0;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('y(t), ')
legend(str_leg)
str_title=(['     (), U_0 = '...
,num2str(U0),' ,  = ',num2str(T),' ']);
title(str_title)
line([0 T],[U0 U0],'LineStyle','--')
line([T T],[0 U0],'LineStyle','--')
subplot(2,1,2)
plot(t,ys)
grid
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('y(t), ')
legend(str_leg)
str_title=(['     (), U_0 = '...
,num2str(U0),' ,  = ',num2str(T),' ']);
title(str_title)
line([0 T],[U0 U0],'LineStyle','--')
line([T T],[0 U0],'LineStyle','--')