% ..  .
%   MATLAB. 2023
%Script 4.3
%       
clear all; close all; clc
%  
% 
U0=1;
% ""
a=1;
%     
tmin=0; tmax=4/a;
%   
dt=.01;
%  
t=0:dt:tmax;
%  
vtau=[.1 .2 .5];
%  
y=zeros(length(t),length(vtau));
ys=zeros(length(t),length(vtau));
str_leg=cell(length(vtau),1);
%  
x=U0*exp(-a*t).*(t>=0);
%      
for k=1:length(vtau)
tau=vtau(k);
str_leg{k}=['\tau_c = ',num2str(tau),' '];
%  
if a*tau~=1
yf=@(t) U0/(a*tau-1)*(exp(-t/tau)-exp(-a*t)).*(t>=0);
else
yf=@(t) U0*t/tau.*exp(-t/tau).*(t>=0);    
end
y(:,k)=yf(t);
%  
sys=tf([0 1],[tau 1]);
% 
ys(:,k)=lsim(sys,x,t); 
%   
dy=max(abs(y(:,k)-ys(:,k)));
fprintf('     %f :\n',tau)
fprintf('-  : %e .\n',dy)
end
% 
subplot(2,1,1)
plot(t,y,t,x,'b--')
grid
ymin=0; ymax=1.1*U0;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('y(t), ')
legend(str_leg)
str_title=(['     (), U_0 = '...
,num2str(U0),' , \alpha = ',num2str(a),' ^{-1}']);
title(str_title)
subplot(2,1,2)
plot(t,ys,t,x,'b--')
grid
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('y(t), ')
legend(str_leg)
str_title=(['     (), U_0 = '...
,num2str(U0),' , \alpha = ',num2str(a),' ^{-1}']);
title(str_title)