% ..  .
%   MATLAB. 2023
%Script 4.4
%     
clear all, close all;  clc
%  
%  
Fc=1;
%  
Wc=2*pi*Fc;
%  
tau=1/Wc;
%     
fmin=0; fmax=3*Fc;
%   
df=.01;
%  
f=fmin:df:fmax;
%  
vn=[1 2 4];
%     
tmin=0; tmax=floor((10+(max(vn)))*tau);
%   
dt=.01;
%  
t=tmin:dt:tmax;
%  
nb=length(vn);
nt=length(t);
nf=length(f);
A=zeros(nf,nb);
Fi=zeros(nf,nb);
h=zeros(nt,nb);
g=zeros(nt,nb);
y=zeros(nt,nb);
str_leg=cell(nb,1);
%     n
disp(' :')
for kb=1:nb
n=vn(kb); 
fprintf('-  n = %u',n)
str_leg{kb}=['n = ',num2str(n)];
%,    -
[z,p,k]=buttap(n);
%   
[b,a]=zp2tf(z,p,k);
%  
[b,a]=lp2lp(b,a,Wc);
%  
sys=tf(b,a)
% 
H=freqresp(sys,f,'Hz');
A(:,kb)=abs(H);
Fi(:,kb)=unwrap(angle(H));
h(:,kb)=impulse(sys,t);
g(:,kb)=step(sys,t);
end
% 
%
subplot(2,2,1)
plot(f,A)
grid
ymin=0; ymax=1.1;
xlim([fmin fmax])
ylim([ymin ymax])
xlabel('f, ')
ylabel('|H(f)|')
title([' , F_c = ',num2str(Fc),' , \tau_c = ',...
num2str(tau),' '],'Units','normalized','Position',[1.155 1.03 0])
legend(str_leg)
line([0 Fc],[1 1],'LineStyle','--');
line([0 Fc],[1/sqrt(2) 1/sqrt(2)],'LineStyle','--');
line([Fc Fc],[0 1],'LineStyle','--');
%
subplot(2,2,2)
plot(f,Fi)
grid
nm=max(vn);
ymin=-nm*pi/2-.1; ymax=pi;
xlim([fmin fmax])
ylim([ymin ymax])
xlabel('f, ')
ylabel('\phi(f), ')
legend(str_leg)
line([0 fmax],[0 0],'LineStyle','--')
line([Fc Fc],[0 -nm*pi/4],'LineStyle','--')
for kpi=1:nb
npi=-vn(kpi)*pi/4;
line([0 Fc],[npi npi],'LineStyle','--');
end
% 
subplot(2,2,3)
plot(t,h)
grid
hmin=min(min(h));
hmax=max(max(h));
ymin=hmin-.1; ymax=1.1*hmax;
xlim([tmin tmax])
ylim([ymin ymax]) 
xlabel('t, ')
ylabel('h(t), ^{-1}')
legend(str_leg)
line([0 tmax],[0 0],'LineStyle','--')
line([tau 0],[0 hmax],'LineStyle','--')
% 
subplot(2,2,4)
plot(t,g)
grid
gmax=max(max(g));
ymin=0; ymax=1.1*gmax;
xlim([tmin tmax])
ylim([ymin ymax]) 
xlabel('t, ')
ylabel('k(t)')
legend(str_leg,'Location','SouthEast')
line([0 tmax],[1 1],'LineStyle','--')
line([0 tau],[0 1],'LineStyle','--')
line([tau tau],[1 0],'LineStyle','--')