% ..  .
%   MATLAB. 2023
%Script 4.5
%    
%    
clear all, close all;  clc
%  
%  
tau=.1;
% 
W=1/tau;
%  
vn=[1 2 3];
nb=length(vn);
% 
U0=2;
%  
T=1;
% ""   
alpha=1;
%     
tmin=0; tmax=2*T;
%   
dt=.01;
%  
t=tmin:dt:tmax;
%  
nt=length(t);
%  
x1=U0*rectpuls(t-T/2,T);
%  
x2=U0*exp(-alpha*t).*(t>=0);
%  
y1=zeros(nt,nb);
y2=zeros(nt,nb);
str_leg=cell(nb,1);
%     
disp(' :')
for kb=1:nb
n=vn(kb); 
fprintf('-  n = %u',n)
str_leg{kb}=['n = ',num2str(n)];
%   -
[z,p,k]=buttap(n);
%   
[b,a]=zp2tf(z,p,k);
%  
[b,a]=lp2lp(b,a,W);
%  
sys=tf(b,a)
% 
y1(:,kb)=lsim(sys,x1,t); 
y2(:,kb)=lsim(sys,x2,t); 
end
%    
subplot(2,1,1)
plot(t,y1)
grid
hmin=min(min(y1));
hmax=max(max(y1));
ymin=2*hmin; ymax=hmax+.1*hmax;
xlim([tmin tmax])
ylim([ymin ymax]) 
line([0 T],[U0 U0],'LineStyle','--');
line([T T],[0 U0],'LineStyle','--');
xlabel('t, ')
ylabel('y(t), ')
legend(str_leg)
str_title1=[' , \tau_c = ',num2str(tau),...
' ^{-1}, \Omega_c = ',num2str(W),' /'];
str_title2=['   , U_0 = '...
,num2str(U0),' ,  = ',num2str(T),' '];
title({str_title1;str_title2})
%    
subplot(2,1,2)
plot(t,y2,t,x2,'b--')
grid
ymin=0; ymax=U0+.1;
xlim([tmin tmax])
ylim([ymin ymax]) 
xlabel('t, ')
ylabel('y(t), ')
legend(str_leg)
str_title=(['   , U_0 = '...
,num2str(U0),' , \alpha = ',num2str(alpha),' ^{-1}']);
title(str_title)