% ..  .
%   MATLAB. 2023
%Script 4.7
%     
%  
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
%     
tmin=-T/2; tmax=3/2*T;
%   
dt=.01;
%  
t=tmin:dt:tmax;
%    (  )
vF=[2/T 4/T 6/T 8/T];
% 
nF=length(vF);
%  
y=zeros(length(t),nF);
yF=zeros(length(t),nF);
%  
for k=1:nF
F=vF(k);
%
y(:,k)=U0/pi*(sinint(2*pi*F*(t))-sinint(2*pi*F*(t-T)));
%
yF(:,k)=integral(@(f)U0*T*sinc(f*T).*cos(2*pi*f*(t-T/2)),-F,F,'ArrayValued',true);
end
% 
%1-  ()
ymax=max(max(y))+.1*U0;
ymin=min(min(y))-.1;
for k=1:nF
F=vF(k);
subplot(nF/2,nF/2,k)
plot(t,y(:,k),t,U0*rectpuls(t-T/2,T),'b--')
grid
xlim([tmin tmax])
ylim([ymin ymax]) 
xlabel('t, ')
ylabel('y(t), ')
x0=.2*T;
y0=.2*U0;
str=['F_c = ',num2str(F),' '];
text(x0,y0,str)
if k==1
title(['     (), U_0 = ',...
num2str(U0),' , T = ',num2str(T),' '],...
'Units','normalized','Position',[1.155 1.03 0])    
end
end
%2-  ()
figure
for k=1:nF
F=vF(k);
subplot(nF/2,nF/2,k)
plot(t,yF(:,k),t,U0*rectpuls(t-T/2,T),'b--')
grid
xlim([tmin tmax])
ylim([ymin ymax]) 
xlabel('t, ')
ylabel('y_F(t), ')
x0=.2*T;
y0=.2*U0;
str=['F_c = ',num2str(F),' '];
text(x0,y0,str)
if k==1
title(['     (), U_0 = ',...
num2str(U0),' , T = ',num2str(T),' '],...
'Units','normalized','Position',[1.155 1.03 0])    
end
end
%   
for k=1:nF
F=vF(k);
dy=max(abs(y(:,k)-yF(:,k)));
fprintf('     %f :\n',F)
fprintf('-  : %e .\n',dy)
end