% ..  .
%   MATLAB. 2023
%Script 5.5
%    
clc; clear all; close all
%  
% 
U1=1; U2=2;
% 
T1=1; T2=1.5;
%     
tmin=-1.1*max(T1,T2);
tmax=1.1*max(T1,T2);
% 
dt=.0001;
%  
t=tmin:dt:tmax;
%    
% 
u1=U1*rectpuls(t-T1/2,T1);
u2=U2*rectpuls(t-T2/2,T2);
%  
subplot(3,1,1)
plot(t,u1,t,u2)
grid
xlim([tmin tmax])
ymin=-.1;
ymax=1.1*max(U1,U2);
ylim([ymin ymax])
xlabel('t, ')
ylabel('u_1(t), u_2(t), ')
legend('u_1(t)','u_2(t)','Location','NorthWest')
title(['  u_1(t)  u_2(t)  U_1 = ',num2str(U1),...
' , U_2 = ',num2str(U2),' , T_1 = ',num2str(T1),...
' , T_2 = ',num2str(T2),' ']);   
%    
%    
[rx,lags]=xcorr(u1,u2);
tau=lags*dt;
rc=rx*dt;
% 
subplot(3,1,2)
plot(tau,rc)
grid
ymax=1.1*U1*U2*min(T1,T2);
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('r_{12}(\tau), ')
lg='NorthWest';
if T1<T2; lg='NorthEast'; end
legend('','Location',lg)
%   
Dmin=min(0,T1-T2);
Dmax=max(0,T1-T2);
r_fct=@(t) U1*U2*...
           ((T2+t).*(t<Dmin)...
           +min(T1,T2).*((t>=Dmin) & (t<=Dmax))...
           +(T1-t).*(t>Dmax))...
           .*((t>=-T2) & (t<=T1));
%   
r=r_fct(tau);
subplot(3,1,3)
plot(tau,r)
grid
xlim([-tmax tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('r_{12}(\tau), ')
legend('','Location',lg)
%   
dr=max(abs(rc-r));
fprintf('  : %e .\n',dr)