% ..  .
%   MATLAB. 2023
%Script 7.3
%     
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
% 
B=10;
% 
fd=B/(2*T);
%  
f0=2*fd;
%   
dt=.001*T;
%  
t=-T/2:dt:T/2;
% ""
beta=2*2*pi*fd/T;
%1- 
%   
v=U0*exp(1i*beta*t.^2/2);
%  
u=real(v.*exp(1i*2*pi*f0*t));
%  
subplot(4,1,1)
plot(t,u)
grid
xlabel('t, ')
ylabel('u(t), ')
ymin=-1.1*U0;
ymax=1.1*U0;
ylim([ymin ymax])
str=['    U_0 = ',num2str(U0),' B, T = ',num2str(T),...
    ' , B = ',num2str(f0),', f_d = ',num2str(fd),...
    ' , f_0 = ',num2str(f0),' '];
title(str)
%   
freq=f0+beta*t/(2*pi);
%   
subplot(4,1,2)
plot(t,freq)
grid
xlabel('t, ')
ylabel('f(t), ')
ymin=min(freq)-1;
ymax=max(freq)+1;
ylim([ymin ymax])
%  
a=abs(v);
%   
phi=unwrap(angle(v));
%   
uc=a.*cos(phi);
%   
subplot(4,1,3)
plot(t,uc)
grid
xlabel('t, ')
ylabel('u_c(t), ')
ymin=-1.1*U0;
ymax=1.1*U0;
ylim([ymin ymax])
%   
us=a.*sin(phi);
%   
subplot(4,1,4)
plot(t,us)
grid
xlabel('t, ')
ylabel('u_s(t), ')
ymin=-1.1*U0;
ymax=1.1*U0;
ylim([ymin ymax])
%   
dh=150;
hp=get(gcf,'Position');
h1=hp(1); h2=hp(2)-dh; h3=hp(3); h4=hp(4)+dh;
set(gcf,'Position',[h1 h2 h3 h4])
%2- 
%   
fmax=2.5*fd;
%   
df=.01*fd;
%  
f=-fmax:df:fmax;
%    
x1=sqrt(B/2)*(1+f/fd);
x2=sqrt(B/2)*(1-f/fd);
C=fresnelc(x1)+fresnelc(x2);
S=fresnels(x1)+fresnels(x2);
V=U0*T/sqrt(2*B)*exp(-1i*B/4*(f/fd).^2).*(C+1i*S);
figure
%     
subplot(2,1,1)
plot(f,abs(V))
grid
xlabel('f, ')
ylabel('|V(f)|, /')
xlim([-fmax fmax])
str1='     '; 
str2=[' U_0 = ',num2str(U0),' B, T = ',num2str(T),' , B = ',...
    num2str(B),', f_d = ',num2str(fd),' '];
title({str1;str2})
%     
subplot(2,1,2)
plot(f,angle(V))
grid
xlabel('f, ')
ylabel('\phi(f), ')
xlim([-fmax fmax])